#include <iostream>
#include <vector>
#include <conio.h>

using namespace std;

struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data()
{
    size_t number_count;
    cerr<<"Enter number count: ";
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    for (size_t i =0; i < number_count; i++)
    {
        cin >> in.numbers[i];
    }
    cerr<< "Enter bin count: ";
    cin >> in.bin_count;
    return in;
}
void find_minmax(const vector<double> &numbers, double &min, double &max)
{
    min = numbers[0];
    max = numbers[0];
       for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }
    return;
}

vector<size_t> make_histogram (vector<double> numbers, size_t bin_count)
{

    double min;
    double max;
    find_minmax (numbers, min, max);
    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count);

    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }

        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }

    return bins;
}

void show_histogram_text(vector<size_t> bins, size_t bin_count)
{
    const size_t screen_width = 80;
    const size_t max_asterisk = screen_width - 3 - 1;
    size_t i,j;
    double max_count;
    max_count = bins[0];
    for (i=0; i< bin_count; i++)
    {
        if (max_count<bins[i])
        {
            max_count=bins[i];
        }
    }

    size_t height;
    bool flag = false;
    if(max_count>max_asterisk)
    {
        flag=true;
    }
    for (j = 0; j < bin_count; j++)
    {
        if (bins[j] < 100)
        {
            cout << " ";
        }
        if (bins[j] < 10)
        {
            cout << " ";
        }
        cout << bins[j] << "|";

        if (flag)
        {
            height = max_asterisk * (static_cast<double>(bins[j]) / max_count);
        }
        else
        {
            height=bins[j];
        }
        for (i = 0; i < height; i++)
        {
            cout << "*";
        }
        cout << endl;
    }
}


int main()
{
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.bin_count);
    getch();
    return 0;
}
